import processing.core.*; 
import processing.xml.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class Dopagem_P extends PApplet {

float PARAMETRO = 50; // par\u00e2metro de rede, \u00e9 a dist\u00e2ncia entre os centros de \u00e1tomos vizinhos

float RAIO = PARAMETRO/8; // raio dos el\u00e9trons

boolean roda; // vari\u00e1vel de anima\u00e7\u00e3o

Credito credito;

Par[][] par; // matriz de pares de posi\u00e7\u00f5es

Positivo p;

boolean campo;

Botao aplicaCampo;

PFont f; // fonte do texto

PFont fatomo; // fonte dos elementos

///////////////////////////SETUP////////////////////////////////////////////////////////////////////
public void setup(){
  size(600, 700);
  stroke(0, 0, 255);
  smooth();  
  par = new Par[8][15];
  
  //iniciamos os pares de posi\u00e7\u00f5es
  for(int i = 0; i < 8; i++)
    for(int j = 0; j < 15; j++){
      if(j % 2 == 0)
        par[i][j] = new Par(PARAMETRO*(i + 1.5f), PARAMETRO*(j*.5f + 1.5f) , "HORIZONTAL");
      else if(j % 2 != 0)
        par[i][j] = new Par(PARAMETRO*(i + 1.0f), PARAMETRO*(j*.5f + 1.5f) , "VERTICAL");
      par[i][j].i = i;
      par[i][j].j = j;
  }

  //iniciamos os portadores de carga (positivos e/ou negativos)
  
  p = new Positivo(par[2][2].p2.x, par[2][2].p2.y, par[2][2], par[2][2].p2, par[3][3], par[3][3].p1);
  
 roda = false;
 //roda = true;
  
  f = loadFont("CourierNewPS-BoldMT-28.vlw"); 
  
  fatomo = createFont("Calibri-Bold-18.vlw", 18);
  
  credito = new Credito();
  
  aplicaCampo =  new Botao(17*width/20, par[4][9].ypos + width/10, width/10, 18, "APLICAR");
  
  //definimos se h\u00e1 ou n\u00e3o campo el\u00e9trico
  campo = false;
}

////////////////////////////////DRAW/////////////////////////////////////////////////////////////////
public void draw(){
  background(255); 
  
  escreveTexto();
  
  pushMatrix();
  translate(0, height/16);
  desenhaAtomos();
  
  for(int i = 0; i < 8; i++)
    for(int j = 0; j < 15; j++){
      if(j % 2 != 0 || i < 7)
        par[i][j].display();
    }
    
  p.display();  
  desenhaCampo(17*width/20, par[4][9].ypos - height/12);
  popMatrix();
    
  if(roda == true){
    conduz();
  }
  
  botaoDisplay();
  credito.display();
}


////////////////////////////////FUN\u00c7\u00d4ES/////////////////////////////////////////////////////////////////////
public void escreveTexto(){
  textAlign(CENTER);
  textFont(f, 38);
  fill(100);
  text("Dopagem 'P'", width/2, height/12); //t\u00edtulo
  
  textFont(f, 13);
  if(!roda)
    text("  Clique em qualquer lugar para iniciar a anima\u00e7\u00e3o  ", width/2, height/8);
  
  text("Quando adicionamos ao semicondutor uma impureza substitucional com\n" + 
       "um n\u00famero menor de el\u00e9trons na camada de val\u00eancia, algumas liga\u00e7\u00f5es\n" + 
       "covalentes ficam deficientes em el\u00e9trons.\n\n" + 
       "Estas defici\u00eancias s\u00e3o chamadas de \u2018buracos eletr\u00f4nicos\u2019,\n" + 
       "e consistem em portadores de cargas positivas.\n\n" +
     //  "O processo descrito \u00e9 chamado de \u2018dopagem do tipo p\u2019.\n" + 
       " Acima, ilustramos a dopagem tipo 'P' do sil\u00edcio (Si) pela\n" + 
       "inser\u00e7\u00e3o de um \u00e1tomo de boro (B) na estrutura cristalina do Si.\n\n" +
       "Altere a atua\u00e7\u00e3o do campo el\u00e9trico, com movimentos do mouse,\n" + 
       "e veja como o buraco eletr\u00f4nico age na condu\u00e7\u00e3o el\u00e9trica.",
       width/2, 35*height/48);
  
  
}

public void desenhaAtomos(){
  textFont(fatomo, 18);
  textAlign(CENTER);
  stroke(0, 0, 255);
  for(int i = 0; i < 7; i++)
    for(int j = 0; j < 14; j++)
      if(j%2 == 0){        
        fill(255);
        ellipse(par[i][j].xpos, par[i][j+1].ypos, PARAMETRO/2, PARAMETRO/2);
        fill(0, 0, 255);
        text("Si", par[i][j].xpos, par[i][j+1].ypos + 6);
      }
  
  if(roda)    
    stroke(0, 0, 255);
  else
    stroke(0, 180, 0);
    
  fill(255);
  ellipse(par[2][2].xpos, par[2][3].ypos, PARAMETRO/2, PARAMETRO/2);
  
  if(roda)
    fill(0, 0, 255);
  else
    fill(0, 180, 0);
    
  text("B", par[2][2].xpos, par[2][3].ypos + 6); 
}
  

public void conduz(){
  
  float campoX = (mouseX - /*width/2*/ par[4][9].xpos + PARAMETRO/2)*2.0f/PARAMETRO;
  if(abs(campoX) < 1)
    campoX = 1;
  float campoY = (mouseY - /*height/2*/par[4][9].ypos)*2.0f/PARAMETRO;
  if(abs(campoY) < 1)
    campoY = 1;
  
  if(p.k == 1){
    
    float r = random(-1, 1);
    float sinal = (abs(r))/r;
    int i = p.pproximo.i;
    int j = p.pproximo.j;    
   
    if(p.pproximo.direcao == "HORIZONTAL"){
      
      if(campo == true)
        r = random(min(campoX, -1),max(campoX, 1));
      else
        r = random(-1, 1);
      
      sinal = (abs(r))/r;
      
      if( sinal > 0 ){           //     sinal positivo -> desloca para a direita
        if(i == 7) 
          i = 0;                 //     sinal negativo -> desloca para a esquerda (i se mant\u00e9m, mas j muda)
        else
          i = i + 1;
      }
        
      if(campo == true)
        r = random(min(campoY, -1), max(campoY, 1));
      else if(campo == false)  
        r = random(-1, 1);
        
      sinal = (abs(r))/r;
      
      if( sinal < 0) {         //    sinal negativo -> desloca para cima
        if(j == 0)
          p = new Positivo(par[i][14].p2.x, par[i][14].p2.y, par[i][14], par[i][14].p2, par[i][13], par[i][13].p2);
        else
          p = new Positivo(p.proximo.x, p.proximo.y, p.pproximo, p.proximo, par[i][j-1], par[i][j-1].p2);
      }
      
      else if( sinal > 0){    // sinal positivo -> desloca para baixo
        if(j == 14)
          p = new Positivo(par[i][0].p1.x, par[i][0].p1.y, par[i][0], par[i][0].p1, par[i][1], par[i][1].p1);
        else
          p = new Positivo(p.proximo.x, p.proximo.y, p.pproximo, p.proximo, par[i][j+1], par[i][j+1].p1);
      }
    
    }
    
    else if(p.pproximo.direcao == "VERTICAL"){
        
      if(campo == true)
        r = random(min(campoY, -1), max(campoY,1));
      else if(campo == false)  
        r = random(-1, 1);
        
      sinal = (abs(r))/r;
      
      if( sinal > 0 ){
        if(j == 14)
          j = 0;
        else
          j = j + 1;
      }
      else if( sinal < 0  ){
        if(j == 0)
          j = 14;
        else
          j = j - 1;
      }
      
      if(campo == true)
        r = random(min(campoX, -1), max(campoX, 1));
      else if(campo == false)
        r = random(-1, 1);
        
      sinal = (abs(r))/r;
      
      if( sinal < 0 ){
        if(i == 0){
          if(j == 0)
            p = new Positivo(par[6][j].p2.x, par[6][j].p2.y, par[6][j], par[6][j].p2, par[5][j], par[5][j].p2);
          else if(j > 0){
            if( j % 2 == 1)
              p = new Positivo(par[6][j].p2.x, par[6][j].p2.y, par[6][j], par[6][j].p2, par[5][j - 1], par[5][j - 1].p2);
            else
              p = new Positivo(par[6][j].p2.x, par[6][j].p2.y, par[6][j], par[6][j].p2, par[6][j - 1], par[6][j - 1].p2);
              
          }
            
        }
        else      
          p = new Positivo(p.proximo.x, p.proximo.y, p.pproximo, p.proximo, par[i - 1][j], par[i - 1][j].p2);
      }
      else if( sinal > 0 ){
        if(i == 7)
          {
            if(j == 14)
              p = new Positivo(par[0][j].p1.x, par[0][j].p1.y, par[0][j], par[0][j].p1, par[1][j - 1], par[1][j - 1].p1);
            else if(j < 14)              
              p = new Positivo(par[0][j].p1.x, par[0][j].p1.y, par[0][j], par[0][j].p1, par[1][j + 1], par[1][j + 1].p1);
          }
        else  
          p = new Positivo(p.proximo.x, p.proximo.y, p.pproximo, p.proximo, par[i][j], par[i][j].p1);
      }
    }
  }
     
  p.desloca();
}

//desenha a setinha que indica o sentido do campo el\u00e9trico


public void desenhaCampo(float x, float y){
  float campoX = mouseX - /*width/2;*/ par[4][9].xpos + PARAMETRO/2;
  float campoY = mouseY - /*height/2;*/ par[4][9].ypos;
  
  //nova origem: centro da seta
  pushMatrix();
  translate(x, y);
  //translate(17*width/20, par[4][9].ypos);
  
  //texto
  textFont(fatomo, 15);
  textAlign(CENTER);
  text("Campo El\u00e9trico", 0, -width/10);
  
  
  
  //desenhamos a seta de sentido, se houver movimento
  if(roda && campo){
    
    strokeWeight(4);
    float mod = sqrt((campoX*campoX + campoY*campoY)/(width*width/4 + height*height/4));
    /*
    line(-40*mod, 30, 40*mod, 30); // representa o m\u00f3dulo do vetor campo el\u00e9trico
    */
    
    //rota\u00e7\u00e3o
    if( abs(campoX) > .1f && abs(campoY) > .1f ){
      rotate( atan(campoY/campoX) );
      if(campoX < 0)
        rotate(PI);
    }
    
    else if( campoX < -.1f && abs(campoY) < .1f )
      rotate(PI);
  
    else if( abs(campoX) < .1f && abs(campoY) > .1f){
      if(campoY > 0)
        rotate(+PI/2);
      else if(campoY < 0)
        rotate(-PI/2);
    }
      stroke(0, 0, 255);
      strokeWeight(1);
      /*
      line(-20, 0, 20, 0);
      line(15, -5, 20, 0); // desenha o sentido do vetor campo
      line(15, 5, 20, 0);
      */
      if(40*sqrt(2)*mod > 5){
        line(-40*mod, 0, 40*mod, 0);
        line(40*mod - 5, -5, 40*mod, 0);          //desenha o vetor campo, com o comprimento correspondendo a seu m\u00f3dulo
        line(40*mod - 5, 5, 40*mod, 0);
      }
      else
        ellipse(0, 0, PARAMETRO/10, PARAMETRO/10);
    }
    
  //caso contr\u00e1rio, desenhamos apenas uma bola
  else {
    ellipse(0, 0, PARAMETRO/10, PARAMETRO/10);
  }
  
  popMatrix();
}

public void botaoDisplay(){
  rectMode(CENTER);
  textFont(fatomo, 12);
  aplicaCampo.display();
  //rectMode(CORNERS);
  textFont(f, 12);
}

public void mousePressed(){
  
  /*
  if(roda){  
    
    roda = false; 
    
  for(int i = 0; i < 8; i++)
    for(int j = 0; j < 15; j++){
      if(j % 2 == 0)
        par[i][j] = new Par(PARAMETRO*(i + 1.5), PARAMETRO*(j*.5 + 1.5) , "HORIZONTAL");
      else if(j % 2 != 0)
        par[i][j] = new Par(PARAMETRO*(i + 1.0), PARAMETRO*(j*.5 + 1.5) , "VERTICAL");
      par[i][j].i = i;
      par[i][j].j = j;
  }

  p = new Positivo(par[2][2].p2.x, par[2][2].p2.y, par[2][2], par[2][2].p2, par[3][3], par[3][3].p1);
  }
   
  
  else if(!roda)
    roda = true;
  */
  
  roda = true;
  
  //campo = !campo;
  aplicaCampo.mousePressed();  
  credito.botao.mousePressed();
  credito.display();
}

public void mouseReleased(){
  aplicaCampo.mouseReleased();
  
  if(aplicaCampo.situacao == "SELECIONADO"){
    campo = true;
    aplicaCampo.texto = "RETIRAR";
  }
  
  else if(aplicaCampo.situacao == "LIBERADO"){
    campo = false;
    aplicaCampo.texto = "APLICAR";
  }
  credito.botao.mouseReleased();
}
    
  
// BOT\u00c3O///

class Botao{
  float xpos, ypos; // coordenadas do centro do bot\u00e3o
  
  String texto, // guarda o texto a ser impresso no bot\u00e3o
  
         situacao, // guarda a situa\u00e7\u00e3o em que se encontra o bot\u00e3o, podendo estar "LIBERADO", "PRESSIONADO" ou "SELECIONADO"
  
         psituacao;  // guarda a situa\u00e7\u00e3o 'est\u00e1vel' que o bot\u00e3o assumira antes de ser pressionado pela \u00faltima vez
                     // (pode guardar "LIBERADO" ou "SELECIONADO") 
  
  float comprimento; // comprimento de refer\u00eancia do bot\u00e3o (ret\u00e2ngulo interno)
  
  float altura; // altura de refer\u00eancia do bot\u00e3o (ret\u00e2ngulo interno)
  
  
  //CONSTRUTORA SIMPLES//
  Botao(float _xpos, float _ypos, String _texto){
    xpos = _xpos;
    ypos = _ypos;
    texto = _texto;
    situacao = "LIBERADO";        // a priore, o bot\u00e3o \u00e9 iniciado como se n\u00e3o estivesse ativado 
    psituacao = "SELECIONADO";    // caso queiramos que ele apresente-se 'selecionado' logo de
                                  // in\u00edcio, trocamos estas vari\u00e1veis apos a chamada da fun\u00e7\u00e3o
                                  // construtora (tratam-se de par\u00e2metros PUBLICOS)
                                  
    //comprimento = 12*texto.length();
    
    // dimens\u00f5es-padr\u00e3o
    altura = 20;    
    comprimento = 92;
  }

  //CONSTUTRUTORA EXTENDIDA (entramos com os valores de 'comprimento' e 'altura' do ret\u00e2ngulo interno do bot\u00e3o)
  Botao(float _xpos, float _ypos, float _comprimento, float _altura, String _texto){
    xpos = _xpos;
    ypos = _ypos;
    comprimento = _comprimento;
    altura = _altura;
    texto = _texto;
    situacao = "LIBERADO";        // da mesma forma que na outra construtora 
    psituacao = "SELECIONADO"; 
    }

  //desenhamos o bot\u00e3o
  public void display(){
    noStroke();
    pushMatrix();
    translate(xpos, ypos); //origem: centro do bot\u00e3o
   
    // as cores dos ret\u00e2ngulos dependem da situa\u00e7\u00e3o em que o bot\u00e3o se encontra
    
    //ret\u00e2ngulo externo
    if(situacao == "LIBERADO")
      fill(180);
    else if(situacao == "PRESSIONADO")
      fill(200);
    else if(situacao == "SELECIONADO")
      fill(220);
    
    rect(0, 0, comprimento + 20, altura + 20); // desenhamos o ret\u00e2ngulo
    
    //ret\u00e2ngulo intermedi\u00e1rio
    if(situacao == "LIBERADO")
      fill(200);
    else if(situacao == "PRESSIONADO")
      fill(220);
    else if(situacao == "SELECIONADO")
      fill(180);
    
    rect(0, 0, comprimento + 10, altura + 10); // desenhamos o ret\u00e2ngulo
    
    //ret\u00e2ngulo interno
    if(situacao == "LIBERADO")
      fill(220);
    else if(situacao == "PRESSIONADO")
      fill(180);
    else if(situacao == "SELECIONADO")
      fill(200);
    
    rect(0, 0, comprimento , altura); // desenhamos o ret\u00e2ngulo
    
    //a cor do texto tamb\u00e9m depende da situa\u00e7\u00e3o do bot\u00e3o
    if(situacao == "PRESSIONADO")
      fill(255);
    else
      fill(100);
    
    text(texto, 0, 4); // escrevemos o texto
    
    popMatrix();  
  }
  
  //fun\u00e7\u00e3o chamada pelo clique do bot\u00e3o (embora o nome seja o mesmo da fun\u00e7\u00e3o da biblioteca interna
  //                                     do Processing, esta fun\u00e7\u00e3o n\u00e3o \u00e9 chamada automaticamente
  //                                     pelo clique do mouse. Portanto devemos cham\u00e1-la dentro da
  //                                     fun\u00e7\u00e3o mousePressed do Processing)
  public void mousePressed(){
    float dx = mouseX - xpos;
    float dy = mouseY - ypos;
    
    //se, no momento do clique do mouse, este estiver sobre o bot\u00e3o, o mesmo assume a situa\u00e7\u00e3o "PRESSIONADO"
    if(abs(dx) < (comprimento)/2 && abs(dy) < (altura)/2)
      situacao = "PRESSIONADO";    
  }
  
  //fun\u00e7\u00e3o chamada pela libera\u00e7\u00e3o do bot\u00e3o do mouse (vale o mesmo dito para a fun\u00e7\u00e3o mousePressed)
  public void mouseReleased(){
    
    /*if(situacao == "PRESSIONADO" && psituacao == "LIBERADO"){
      situacao = psituacao;
      psituacao = "SELECIONADO";
    }
    
    if(situacao == "PRESSIONADO" && psituacao == "SELECIONADO"){
      situacao = psituacao;
      psituacao = "LIBERADO";
    }*/
    
    //se o bot\u00e3o foi pressionado, ap\u00f3s a libera\u00e7\u00e3o do mouse o primeiro assume a situa\u00e7\u00e3o "SELECIONADO"
    if(situacao == "PRESSIONADO"){
      
      if(psituacao == "SELECIONADO"){
        situacao = "SELECIONADO";
        psituacao = "LIBERADO";
      }
      else if(psituacao == "LIBERADO"){
        situacao = "LIBERADO";
        psituacao = "SELECIONADO";
      }         
      
    }
      
  }
  
  //fun\u00e7\u00e3o que libera o bot\u00e3o
  public void libera(){
    psituacao = "SELECIONADO";
    situacao = "LIBERADO";
  }

}
class Credito{
  
  Botao botao;
  
  PFont f;
  
  boolean mais;
  
  Credito(){
    botao = new Botao(width - 40, 20, 45, 20, "Cr\u00e9ditos");
    f = loadFont("ArialUnicodeMS-11.vlw");
    mais = false;
  }

 public void display(){     
   textFont(f, 11);
   botao.display();
   rectMode(CORNERS);
   if( botao.situacao == "SELECIONADO" ){
     fill(240, 200);
     textAlign(LEFT);     
     if(mais){
       //rect(width/2, height/2, 400, 400);
       rect(width/2 - 200, height/2 - 200, width/2 + 200, height/2 + 200);
       fill(0);
       text( "\t\t                                                                            CR\u00c9DITOS" +
           "\n\nDesenvolvimento: Gustavo S. Jacomini (2\u00baano, Engenharia Civil-Escola Polit\u00e9cnica)" +
           "\n" + 
           "\n\nOrienta\u00e7\u00e3o: Ivette Frida Cymbaum Oppenheim (Departamento de Engenharia " + 
           "\n                                                                        Metal\u00fargica e de Materiais - Escola Polit\u00e9cnica)" +
           "\n\ncriado em:" + 
//           " Processing" + 
           "\n\n\nO meio:     'Processing' \u00e9 uma linguagem de programa\u00e7\u00e3o e ambiente de" +  
           "\n                      desenvolvimento com foco principal nas artes visuais, apro-" +
           "\n                      veitando-se da plataforma Java e de uma comunidade virtual" + 
           "\n                      de intensa atua\u00e7\u00e3o por meio do compartilhamento de c\u00f3di-" + 
           "\n                      gos e bibliotecas pela internet." + 
           "\n\n                        Surgiu como iniciativa de Casey Reas e Ben Fry, pesquisa-" +
           "\n                      dores do Instituto de Tecnologia de Massachussets (MIT)," +
           "\n                      sendo, desde sua cria\u00e7\u00e3o, disponibilizado gratuitamente co-" +
           "\n                      mo software livre, acess\u00edvel a qualquer interessado a partir" + 
           "\n                      do download no site 'processing.org', onde podem ser en-" +
           "\n                      contradas informa\u00e7\u00f5es adicionais sobre 'Processing'." +    
           "\n\n\nApoio:     'Anima\u00e7\u00f5es para Disciplinas Introdut\u00f3rias de Ci\u00eancia e Engenharia dos"  + 
           "\n                      Materiais' \u00e9 integrante do 'Programa Ensinar com Pesquisa',  iniciativa"  +
           "\n                      da Pr\u00f3-Reitoria de Gradua\u00e7\u00e3o da Universidade de S\u00e3o Paulo,  \u00e0 qual"  +
           "\n                      expressamos nossos agradecimentos (Projeto 598 -  Ano 2009).",width/2 - 190, height/2 - 170);
     }
     
     else if(mais == false){
       rect(width/2 - 200, height/2 - 200, width/2 + 200, height/2 + 30);
       fill(0);
       text( "\t\t                                                                            CR\u00c9DITOS" +
           "\n\nDesenvolvimento: Gustavo S. Jacomini (2\u00baano, Engenharia Civil-Escola Polit\u00e9cnica)" +
           "\n" + 
           "\n\nOrienta\u00e7\u00e3o: Ivette Frida Cymbaum Oppenheim (Departamento de Engenharia " + 
           "\n                                                                        Metal\u00fargica e de Materiais - Escola Polit\u00e9cnica)" +
           "\n\ncriado em:" +     
           "\n\n\nApoio:     'Anima\u00e7\u00f5es para Disciplinas Introdut\u00f3rias de Ci\u00eancia e Engenharia dos"  + 
           "\n                      Materiais' \u00e9 integrante do 'Programa Ensinar com Pesquisa',  iniciativa"  +
           "\n                      da Pr\u00f3-Reitoria de Gradua\u00e7\u00e3o da Universidade de S\u00e3o Paulo,  \u00e0 qual"  +
           "\n                      expressamos nossos agradecimentos (Projeto 598 -  Ano 2009).",width/2 - 190, height/2 - 170);
       
     }
     textAlign(CENTER);
     
     if(!mais)
       fill(0, 0, 150);
     else if(mais)
       fill(150);
     
     if(abs(mouseX - (width/2 - 86)) < 30 && abs(mouseY - (height/2 - 68)) < 10){
       if(mousePressed)
         fill(255);
       else{
         if(!mais)
           fill(100, 100, 255);
         else if(mais)
           fill(200);
       }
     }
     
     text("Processing", width/2 - 86, height/2 - 68);
    
          
   }
   rectMode(CENTER);
 }
 
 class Botao{
  float xpos, ypos; // coordenadas do centro do bot\u00e3o
  
  String texto, // guarda o texto a ser impresso no bot\u00e3o
  
         situacao, // guarda a situa\u00e7\u00e3o em que se encontra o bot\u00e3o, podendo estar "LIBERADO", "PRESSIONADO" ou "SELECIONADO"
  
         psituacao;  // guarda a situa\u00e7\u00e3o 'est\u00e1vel' que o bot\u00e3o assumira antes de ser pressionado pela \u00faltima vez
                     // (pode guardar "LIBERADO" ou "SELECIONADO") 
  
  float comprimento; // comprimento de refer\u00eancia do bot\u00e3o (ret\u00e2ngulo interno)
  
  float altura; // altura de refer\u00eancia do bot\u00e3o (ret\u00e2ngulo interno)
  
  
  //CONSTRUTORA SIMPLES//
  Botao(float _xpos, float _ypos, String _texto){
    xpos = _xpos;
    ypos = _ypos;
    texto = _texto;
    situacao = "LIBERADO";        // a priore, o bot\u00e3o \u00e9 iniciado como se n\u00e3o estivesse ativado 
    psituacao = "SELECIONADO";    // caso queiramos que ele apresente-se 'selecionado' logo de
                                  // in\u00edcio, trocamos estas vari\u00e1veis apos a chamada da fun\u00e7\u00e3o
                                  // construtora (tratam-se de par\u00e2metros PUBLICOS)
                                  
    //comprimento = 12*texto.length();
    
    // dimens\u00f5es-padr\u00e3o
    altura = 20;    
    comprimento = 92;
  }

  //CONSTUTRUTORA EXTENDIDA (entramos com os valores de 'comprimento' e 'altura' do ret\u00e2ngulo interno do bot\u00e3o)
  Botao(float _xpos, float _ypos, float _comprimento, float _altura, String _texto){
    xpos = _xpos;
    ypos = _ypos;
    comprimento = _comprimento;
    altura = _altura;
    texto = _texto;
    situacao = "LIBERADO";        // da mesma forma que na outra construtora 
    psituacao = "SELECIONADO"; 
    }

  //desenhamos o bot\u00e3o
  public void display(){
    noStroke();
    pushMatrix();
    translate(xpos, ypos); //origem: centro do bot\u00e3o
   
    // as cores dos ret\u00e2ngulos dependem da situa\u00e7\u00e3o em que o bot\u00e3o se encontra
    
   /* //ret\u00e2ngulo externo
    if(situacao == "LIBERADO")
      fill(255 - 180);
    else if(situacao == "PRESSIONADO")
      fill(255 - 200);
    else if(situacao == "SELECIONADO")
      fill(255 - 220);
    
    rect(0, 0, comprimento + 20, altura + 20); // desenhamos o ret\u00e2ngulo
    */
    //ret\u00e2ngulo intermedi\u00e1rio
    if(situacao == "LIBERADO")
      fill(200);
    else if(situacao == "PRESSIONADO")
      fill(220);
    else if(situacao == "SELECIONADO")
      fill(180);
    
    rect(0, 0, comprimento + 10, altura + 10); // desenhamos o ret\u00e2ngulo
    
    //ret\u00e2ngulo interno
    if(situacao == "LIBERADO")
      fill(220);
    else if(situacao == "PRESSIONADO")
      fill(180);
    else if(situacao == "SELECIONADO")
      fill(200);
    
    rect(0, 0, comprimento , altura); // desenhamos o ret\u00e2ngulo
    
    //a cor do texto tamb\u00e9m depende da situa\u00e7\u00e3o do bot\u00e3o
    if(situacao == "PRESSIONADO")
      fill(255);
    else
      fill(100);
    
    text(texto, 0, 4); // escrevemos o texto
    
    popMatrix();  
  }
  
  //fun\u00e7\u00e3o chamada pelo clique do bot\u00e3o (embora o nome seja o mesmo da fun\u00e7\u00e3o da biblioteca interna
  //                                     do Processing, esta fun\u00e7\u00e3o n\u00e3o \u00e9 chamada automaticamente
  //                                     pelo clique do mouse. Portanto devemos cham\u00e1-la dentro da
  //                                     fun\u00e7\u00e3o mousePressed do Processing)
  public void mousePressed(){
    float dx = mouseX - xpos;
    float dy = mouseY - ypos;
    
    //se, no momento do clique do mouse, este estiver sobre o bot\u00e3o, o mesmo assume a situa\u00e7\u00e3o "PRESSIONADO"
    if(abs(dx) < (comprimento)/2 && abs(dy) < (altura)/2)
      situacao = "PRESSIONADO";
    
    //gerenciamos a apresenta\u00e7\u00e3o de informa\u00e7\u00f5es adicionais pelo clique sobre a palavra 'Processing'
    if(abs(mouseX - (width/2 - 86)) < 30 && abs(mouseY - (height/2 - 68)) < 10)
      mais = !mais;    
  }
  
  //fun\u00e7\u00e3o chamada pela libera\u00e7\u00e3o do bot\u00e3o do mouse (vale o mesmo dito para a fun\u00e7\u00e3o mousePressed)
  public void mouseReleased(){
    
    /*if(situacao == "PRESSIONADO" && psituacao == "LIBERADO"){
      situacao = psituacao;
      psituacao = "SELECIONADO";
    }
    
    if(situacao == "PRESSIONADO" && psituacao == "SELECIONADO"){
      situacao = psituacao;
      psituacao = "LIBERADO";
    }*/
    
    //se o bot\u00e3o foi pressionado, ap\u00f3s a libera\u00e7\u00e3o do mouse o primeiro assume a situa\u00e7\u00e3o "SELECIONADO"
    if(situacao == "PRESSIONADO" && psituacao == "SELECIONADO"){
      situacao = "SELECIONADO";
      psituacao = "LIBERADO";
    }
    
    if(situacao == "PRESSIONADO" && psituacao == "LIBERADO"){
      situacao = "LIBERADO";
      psituacao = "SELECIONADO";
    }
    
    
       
  }
  
  //fun\u00e7\u00e3o que libera o bot\u00e3o
  public void libera(){
    psituacao = "SELECIONADO";
    situacao = "LIBERADO";
  }

}
}
 
class Negativo{
  float x;
  
  float y;
  
  Par par;
  
  Posicao alvo;
  
  Posicao outro;
  
  float k;
  
  Negativo(float xpos, float ypos,Par p, Posicao pos){
    x = xpos;
    y = ypos;
    par = p;
    alvo = pos;
    if(alvo == par.p1)
      outro = par.p2;
    else if(alvo == par.p2)
      outro = par.p1;
    k = 0;  
  }
  
  public void display(){    
    stroke(0, 0, 255);
    fill(255);
    ellipse(par.p1.x, par.p1.y, RAIO, RAIO);
    ellipse(par.p2.x, par.p2.y, RAIO, RAIO);
    
    fill(0, 0, 255);
    ellipse(alvo.x + k*(outro.x - alvo.x), alvo.y + k*(outro.y - alvo.y), RAIO, RAIO);
    
    stroke(255, 0, 0);
    fill(255, 0, 0);
    ellipse(x + k*(alvo.x - x), y + k*(alvo.y - y), RAIO, RAIO);    
  }
  
  public void desloca(){
    if(k < 1)
      k +=.005f;
    else
      k = 1;
  }  
}
class Par{
  String direcao; //guarda a dire\u00e7\u00e3o em que o par se apresenta (HORIZONTAL ou VERTICAL)
  
  Posicao p1; // uma das posi\u00e7\u00f5es do par eletr\u00f4nico
  
  Posicao p2; // outra posi\u00e7\u00e3o
   
  float xpos; // guarda a coordenada em x do centro do par de posi\u00e7\u00f5es
  
  float ypos; // guarda a coordenada em y do centro do par de posi\u00e7\u00f5es
  
  //ROUBANDO
  int i;
  int j;
  
  Par(float x, float y, String dir){
    xpos = x;
    ypos = y;
    direcao = dir;
    
    //distribuimos as posi\u00e7\u00f5es de acordo com a dire\u00e7\u00e3o em que o par se apresenta
    if(direcao == "VERTICAL"){
      p1 = new Posicao(x, y - PARAMETRO/8);
      p2 = new Posicao(x, y + PARAMETRO/8);
    }
    else if(direcao == "HORIZONTAL"){
      p1 = new Posicao(x - PARAMETRO/8, y);
      p2 = new Posicao(x + PARAMETRO/8, y);
    }
  }
  
  // desenhamos os el\u00e9trons nas posi\u00e7\u00f5es p1 e p2
  public void display(){
    stroke(0, 0, 255);
    fill(0, 0, 255);
    ellipse(p1.x, p1.y, RAIO, RAIO);
    ellipse(p2.x, p2.y, RAIO, RAIO);
  }

  
}  


class Posicao{
    float x;
    float y;
    
    Posicao(float xpos, float ypos){
      x = xpos;
      y = ypos;
    }
  } 
class Positivo{
  
  float x;
  
  float y;
    
  Par par;
  
  Posicao pos;
  
  Par pproximo; //pr\u00f3ximo par
  
  Posicao proximo; //pr\u00f3xima posi\u00e7\u00e3o
  
  Posicao outro; //posi\u00e7\u00e3o do pr\u00f3ximo par que n\u00e3o ser\u00e1 ocupada
  
  float k;
  
  Positivo(float xpos, float ypos, Par pr,  Posicao p, Par pprx, Posicao prx){
    x = xpos;
    y = ypos;
    par = pr;
    pos = p;
    pproximo = pprx;
    proximo = prx;
    if(proximo == par.p1)
      outro = par.p2;
    else if(proximo == par.p2)
      outro = par.p1;
    k = 0;  
  }
  
  public void display(){
    
    if(roda)    
      stroke(0, 0, 255);
    else
      stroke(0, 180, 0);
      
    fill(255);
    ellipse(pos.x, pos.y, RAIO, RAIO);
    stroke(0, 0, 255);
    ellipse(proximo.x, proximo.y, RAIO, RAIO);
    
    
    fill(0, 0, 255);
    ellipse(proximo.x + k*(pos.x - proximo.x), proximo.y + k*(pos.y - proximo.y), RAIO, RAIO); 
  }
  
  public void desloca(){
    if(k < 1)
      k +=.25f;
    else
      k = 1;
  }

}

  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#FFFFFF", "Dopagem_P" });
  }
}
